// calls
// Evita

// --LIST OF CALLS--
// ClientMessage
// ServerMessage
// FlagEvent
// YouHaveFlag
// YouCappedFlag
// TeamHasFlag
// FriendlyFlagTaken
// FriendlyFlagCapture
// EnemyFlagCapture
// FriendlyFlagReturned
// EnemyFlagReturned
// FriendlyFlagDropped
// EnemyFlagDropped
// EnterStation
// ExitStation
// ResupplyComplete
// PortableINV
// PermanantINV
// ExitGame
// MapChange
// Connected
// ConnectionAccepted
// ConnectionRejected
// ConnectionDropped
// ConnectionTimedOut
// ClientTeamAdd
// ClientJoin
// ClientDrop
// ClientChangeTeam
// UpdateTime
// UnitDisabled
// PowerDown
// PlayGuiLoaded
// GuiOpen
// GuiClose
// MatchStarted
// ItemPickup
// Repairing
// RepairStopped
// RepairDone
// FiringOn
// FiringOff
// YouKilled (in KillTrack.cs)
// YouDied (in KillTrack.cs)
 
function onCall::Trigger(%trigger, %p1, %p2, %p3, %p4, %p5, %p6) {

	for(%i=0; %i<=$numOfCalls; %i++) {

		if(%trigger == $Calls[%i]) {
		  eval($Func[%i] @ "(%p1, %p2, %p3, %p4, %p5, %p6);");
		}
	}
}

function onCall(%call, %function) {

	$numOfCalls++;
	
	$Calls[$numOfCalls] = %call;
	$Func[$numOfCalls] = %function;
}

function onClientMessage(%client, %msg) {

	if(%client) {
          $lastClientMessage = %client;
	  %mute = false;
	  onCall::Trigger(ClientMessage, %client, %msg);
	}

	if(!%client) {
	  onCall::Trigger(ServerMessage, %client, %msg);

	// FILTER USELESS SERVER MESSAGES
	if(%msg == "Station Access On")
	  %mute = true;

	else if(%msg == "Station Access Off")
	  %mute = true;

	else if(%msg == "Resupply Complete")
	  %mute = true;

	else if(%msg == "Bought Laser Rifle - Auto buying Energy Pack")
	  %mute = true;

	else if(String::findSubStr(%msg, "You received ") != -1)
          %mute = true;

	else if(String::findSubStr(%msg, "You couldn't buy ") != -1)
          %mute = true;
	
	else
	  %mute = false;

	// FLAG CALLS
	if(String::findSubStr(%msg, "flag") != -1) {
	  onCall::Trigger(FlagEvent, %msg);

	%posit = String::findSubStr(%msg, " took the ");

	if(%posit > 0) {

		$FlagSnatcher = String::getSubStr(%msg, 0, %posit);
	}

	if(String::findSubStr(%msg, "Your team has the ") == 0) {

		if($FlagSnatcher == "You")
		  onCall::Trigger(YouHaveFlag, %msg);
		else
		  onCall::Trigger(TeamHasFlag, %msg);
	}
	else if(%msg == "Your team's flag has been taken.")
	  onCall::Trigger(FriendlyFlagTaken, %msg);

	else if (String::findSubStr(%msg, "You captured ") == 0)
	  onCall::Trigger(YouCappedFlag, %msg);

	else if(%msg == "Your team captured the flag.")
	  onCall::Trigger(FriendlyFlagCapture, %msg);

	else if(%msg == "Your team's flag was captured.")
	  onCall::Trigger(EnemyFlagCapture, %msg);

	else if(String::findSubStr(%msg, "Your flag was returned to base.") == 0)
	  onCall::Trigger(FriendlyFlagReturned, %msg);

	else if(String::findSubStr(%msg, " flag was returned to base.") > 0)
	  onCall::Trigger(EnemyFlagReturned, %msg);

	else if(%msg == "Your flag was dropped in the field.")
	  onCall::Trigger(FriendlyFlagDropped, %msg);

	else if(String::findSubStr(%msg, " flag was dropped in the field.") > 0)
	  onCall::Trigger(EnemyFlagDropped, %msg);
	}

	// INVENTORY CALLS
  	if(%msg == "Station Access On") {
	  onCall::Trigger(EnterStation);

	  if($pref::Ev3rdPersonInvy)
	  postAction(2048, IDACTION_VIEW, 1.000000);
	}

  	else if(%msg == "Station Access Off") {
	  onCall::Trigger(ExitStation);
	  remoteTP(2048, "", 0);
	  $Station::Perm = "";

	  if($pref::Ev3rdPersonInvy)
	  postAction(2048, IDACTION_VIEW, 1.000000);
	}

	else if(%msg == "Resupply Complete") {
	  onCall::Trigger(ResupplyComplete);
	  $Support::Resupplied = "TRUE";
	  schedule("$Support::Resupplied = \"\";", 0.1);
	}

	// POWER CALLS
	else if(%msg == "Unit is disabled")
	  onCall::Trigger(UnitDisabled);

	else if(%msg == "Unit is not powered")
	  onCall::Trigger(PowerDown);

	// MATCH STARTED
	else if(%msg == "Match started.")
	  onCall::Trigger(MatchStarted, %msg);

	// ITEM PICKUPS
	else if(String::findSubStr(%msg, "You received ") != -1)
	  onCall::Trigger(ItemPickup, %msg);

	// REPAIRING
	else if(String::findSubStr(%msg, "Repairing ") != -1)
	  onCall::Trigger(Repairing, %msg);

	else if(%msg == "Repair Stopped")
	  onCall::Trigger(RepairStopped);

	else if(%msg == "Repair Done")
	  onCall::Trigger(RepairDone);

	}

    	return !%mute;
}

function onConnection(%message) {

    	echo("Connection ", %message);
    	$dataFinished = false;

    	if(%message == "Accepted") {

        	resetSimTime();

        	if ($PCFG::Script != "")
            	  exec($PCFG::Script);

        	resetPlayDelegate();
        	remoteEval(2048, "SetCLInfo", $PCFG::SkinBase, $PCFG::RealName, $PCFG::EMail, $PCFG::Tribe, $PCFG::URL, $PCFG::Info, $pref::autoWaypoint, $pref::noEnterInvStation, $pref::messageMask);

        	if ($Pref::PlayGameMode == "JOIN") {

            		cursorOn(MainWindow);
           	 	GuiLoadContentCtrl(MainWindow, "gui\\Loading.gui");
            		renderCanvas(MainWindow);
        	}

	onCall::Trigger(ConnectionAccepted, %message);

    	}
    	else if(%message == "Rejected") {

        	Quickstart();
        	$errorString = "Connection to server rejected:\n" @ $errorString;
        	GuiPushDialog(MainWindow, "gui\\MessageDialog.gui");
        	schedule("Control::setValue(MessageDialogTextFormat, $errorString);", 0);
		onCall::Trigger(ConnectionRejected, %message);
    	}
    	else {

        	Quickstart();

        	if(%message == "Dropped") {

            		if($errorString == "")
                  	  $errorString = "Connection to server lost:\nServer went down.";
            		else
                  	  $errorString = "Connection to server lost:\n" @ $errorString;

            	  	GuiPushDialog(MainWindow, "gui\\MessageDialog.gui");
            	  	schedule("Control::setValue(MessageDialogTextFormat, $errorString);", 0);
		  	onCall::Trigger(ConnectionDropped, %message);
        	}
        	else if(%message == "TimedOut") {

            		$errorString = "Connection to server timed out.";
            		GuiPushDialog(MainWindow, "gui\\MessageDialog.gui");
            		schedule("Control::setValue(MessageDialogTextFormat, $errorString);", 0);
			onCall::Trigger(ConnectedTimedOut, %message);
        	}
    	}
}

function dataFinished() {

    if ($cdMusic && !$pref::userCDOverride) {

            rbSetPlayMode(CD, 0);
            rbStop(CD);
    }

    Control::setValue(ProgressText, "<jc><f0>Get ready to rock n roll!");
    Control::setValue(ProgressSlider, 0.9);

    $dataFinished = true;
    remoteEval(2048, dataFinished);

    onCall::Trigger(Connected);

    echo("Flushing Texture Cache");
    flushTextureCache();
}

function remoteMissionChangeNotify(%serverManagerId, %nextMission) {

    	if(%serverManagerId == 2048) {

		onCall::Trigger(MapChange, %nextMission);

        	echo("Server mission complete - changing to mission: ", %nextMission);
        	echo("Flushing Texture Cache");
        	flushTextureCache();
        	schedule("purgeResources(true);", 3);
    	}
}

function onExit() {

	onCall::Trigger(ExitGame);

    	if(isObject(playGui)) {

            RemoveClickFix(playGui);
            storeObject(playGui, "config\\play.gui");
        }

    	saveActionMap("config\\config.cs", "actionMap.sae", "playMap.sae", "pdaMap.sae");

    	checkMasterTranslation();

    	echo("exporting pref::* to prefs.cs");
    	export("pref::*", "config\\ClientPrefs.cs", False);
    	export("Server::*", "config\\ServerPrefs.cs", False);
    	export("pref::lastMission", "config\\ServerPrefs.cs", True);
    	BanList::export("config\\banlist.cs");
}

function onTeamAdd(%team, %name) {

	onCall::Trigger(ClientTeamAdd, %team, %name);
}

function onClientJoin(%client) {

    	onCall::Trigger(ClientJoin, %client);
}

function onClientDrop(%client) {

    	onCall::Trigger(ClientDrop, %client);
}

function onClientChangeTeam(%client, %team) {

    	onCall::Trigger(ClientChangeTeam, %client, %team);
}

function remoteSetTime(%server, %time) {

    	if(%server == 2048)
          setHudTimer(%time);

    	%time = (-%time + $tweakTime);
    	%min = Time::getMinutes(%time);
    	%sec = Time::getSeconds(%time);
	
    	if(%min > 59)
      	  return;

    	onCall::Trigger(UpdateTime, %min, %sec);
}

// GUI STUFF

function PlayGui::onOpen() {

    	$Mode::OptionsMode = false;
    	$Mode::PlayMode = true;

	onCall::Trigger(GuiOpen, playGui);
}

function PlayGui::onClose() {

	onCall::Trigger(GuiClose, playGui);
    	$Mode::PlayMode = false;
}

function loadPlayGui() {

	if(File::FindFirst("play.gui") != "") {

		GuiLoadContentCtrl(MainWindow, "play.gui");
	}

	else {
		GuiLoadContentCtrl(MainWindow, "gui\\play.gui");
	}

	if(!$PlayGUI::isLoaded) {

		onCall::Trigger(PlayGuiLoaded);
     		$PlayGUI::isLoaded = 1;
	}
}

function MainMenuGui::OnOpen() {

	onCall::Trigger(GuiOpen, MainMenuGui);
}

function MainMenuGui::OnClose() {

	onCall::Trigger(GuiClose, MainMenuGui);
}

function CmdInventoryGui::onOpen() {

   if($curFavorites == -1) {

      CmdInventoryGui::favoritesSel(1);
      Control::performClick("FavButton1");
   }
	onCall::Trigger(GuiOpen, CmdInventoryGui);
}

function CmdInventoryGui::onClose() {

	onCall::Trigger(GuiClose, CmdInventoryGui);
}

function CommandGui::onOpen() {

	if ($pref::mapFilter & 0x0001) Control::setValue(IDCTG_CMDO_PLAYERS, "TRUE");
	else Control::setValue(IDCTG_CMDO_PLAYERS, "FALSE");

	if ($pref::mapFilter & 0x0002) Control::setValue(IDCTG_CMDO_TURRETS, "TRUE");
	else Control::setValue(IDCTG_CMDO_TURRETS, "FALSE");

	if ($pref::mapFilter & 0x0004) Control::setValue(IDCTG_CMDO_ITEMS, "TRUE");
	else Control::setValue(IDCTG_CMDO_ITEMS, "FALSE");

	if ($pref::mapFilter & 0x0008) Control::setValue(IDCTG_CMDO_OBJECTS, "TRUE");
	else Control::setValue(IDCTG_CMDO_OBJECTS, "FALSE");

	if (String::ICompare($pref::mapSensorRange, "TRUE") == 0) Control::setValue(IDCTG_CMDO_RADAR, "TRUE");
	else Control::setValue(IDCTG_CMDO_RADAR, "FALSE");

	if (String::ICompare($pref::mapNames, "TRUE") == 0) Control::setValue(IDCTG_CMDO_EXTRA, "TRUE");
	else Control::setValue(IDCTG_CMDO_EXTRA, "FALSE");

	Control::setValue("TVButton", false);

	schedule("CommandGui::TV();", 0.25);

	onCall::Trigger(GuiOpen, CommandGui);
}

function CommandGui::onClose() {

	onCall::Trigger(GuiClose, CommandGui);
}

function CommandGui::TV() {

	Client::ToggleCmdObserver("True");
	Control::setValue("TVButton", true);
}

// Advanced scheduling (Writer)

function Schedule::Add(%eval, %time, %tag) {

	if(%tag == "")
	  %tag = %eval;

	$Schedule::ID[%tag]++;
	$Schedule::eval[%tag] = %eval;
	schedule("Schedule::Exec(\""@escapestring(%tag)@"\", "@$Schedule::ID[%tag]@");", %time);
}

function Schedule::Exec(%tag, %id) {

	if($Schedule::ID[%tag] != %id)
	  return;

	%eval = $Schedule::eval[%tag];
	Schedule::Cancel(%tag);
	eval(%eval);
}

function Schedule::Cancel(%tag) {

	$Schedule::ID[%tag]++;
	$Schedule::eval[%tag] = "";
}

// REMOTE INVY CHECK (MrPoop)

function remoteITXT(%manager, %msg) {

	if(String::FindSubStr(%msg, "Station") != -1) {
		onCall::Trigger(PortableINV);
		
		if($pref::EvStationEnergy)
		remoteTP(2048, "<jc><f0>" @ %msg, 999);
	}

	else if($Station::Perm != "TRUE" && $Support::Resupplied != "TRUE") {
		$Station::Perm = "TRUE";
		onCall::Trigger(PermanantINV);
	}

	if(%manager == 2048) {
		Control::setValue(EnergyDisplayText, %msg);
	}
}

// FIRE WEAPON

function FireWeapon(%val) {

	if(%val) {
  		if($pref::EvReverseSniper && getMountedItem(0) == 22) {
    		}
  		else {
    		  postAction(2048, IDACTION_FIRE1, 0);
		  $Firing = true;
		  onCall::Trigger(FiringOn);
		}
	}

	else {
  		if($pref::EvReverseSniper && getMountedItem(0) == 22) {

            	  postAction(2048, IDACTION_FIRE1, 0);
		  onCall::Trigger(FiringOn);
      		  postAction(2048, IDACTION_BREAK1, 0);
		  onCall::Trigger(FiringOff);
		  $Firing = false;
		}

  		else {

		  postAction(2048, IDACTION_BREAK1, 0);
		  $Firing = false;
		  onCall::Trigger(FiringOff);
		}
	}
}

// Jump Jet

function Jump::Jet(%val) {

	if(%val) {

    	  if(getMountedItem(0) == -1)
      	    postAction(2048, IDACTION_JET, 1);

    	  else {

      	    postAction(2048, IDACTION_MOVEUP, 1);
      	    postAction(2048, IDACTION_JET, 1);
	  }
	}

	else
      	    postAction(2048, IDACTION_JET, 0);
}




