// flag
// Evita

$Flag::Xpos = "0";
$Flag::Ypos = "723";

function Flag::Init() {


	if($FlagHUD::Loaded)
	  return;

	$FlagHUD::Loaded = true;

	$Ftimer = 48;
	$Etimer = 48;
	$Escore = 0;
	$Fscore = 0;

	$FlagHUD::Container = newObject("FlagHUD_Container", SimGui::Control, $Flag::Xpos, $Flag::Ypos, 185, 45);
	$FlagHUD[0] = newObject("FlagHUD_BG", FearGui::FearGuiMenu, 0, 0, 185, 45);
	$FlagHUD[1] = newObject("FlagHUD_Friendly", FearGuiFormattedText, 20, 6, 0, 0);
	$FlagHUD[2] = newObject("FlagHUD_Enemy", FearGuiFormattedText, 20, 24, 0, 0);
	$FlagHUD[3] = newObject("FlagHUD_EnemyScore", FearGuiFormattedText, 10, 6, 0, 0);
	$FlagHUD[4] = newObject("FlagHUD_FriendlyScore", FearGuiFormattedText, 10, 24, 0, 0);

	control::setVisible("FlagHUD_BG", true);

	for(%i = 0; $FlagHUD[%i] != ""; %i++)
	  addToSet($FlagHUD::Container, $FlagHUD[%i]); 

	Flag::Update();
}

function Flag::Update() {

	if(!$Mode::PlayMode)
	  return;

	if ($FlagHUD::FriendlyCarrier == "")
		$FlagHUD::CarrierStatus_Friendly = "<f2>  Home";
	else if ($FlagHUD::FriendlyCarrier == "DROPPED")
		$FlagHUD::CarrierStatus_Friendly = "<f2>  Dropped " @ $Etimer;
	else
                $FlagHUD::CarrierStatus_Friendly = "<f2>  " @ $FlagHUD::FriendlyCarrier;

	if ($FlagHUD::EnemyCarrier == "")
		$FlagHUD::CarrierStatus_Enemy = "<f1>  Home";
	else if ($FlagHUD::EnemyCarrier == "DROPPED")
		$FlagHUD::CarrierStatus_Enemy = "<f1>  Dropped " @ $Ftimer;

	else
                $FlagHUD::CarrierStatus_Enemy = "<f1>  " @ $FlagHUD::EnemyCarrier;

		$FriendlyScore = "<f1>" @ $Fscore;
		$EnemyScore = "<f2>" @ $Escore;

        Control::setValue("FlagHUD_Friendly", $FlagHUD::CarrierStatus_Friendly);
        Control::setValue("FlagHUD_Enemy", $FlagHUD::CarrierStatus_Enemy);
        Control::setValue("FlagHUD_EnemyScore", $EnemyScore);
        Control::setValue("FlagHUD_FriendlyScore", $FriendlyScore);
}

function Flag::GuiOpen(%gui) {

	if(%gui != playGui)
	  return;

	addToSet(playGui, $FlagHUD::Container);
	
	Flag::Update();
}

function Flag::GuiClose(%gui) {

	if(%gui != playGui)
	  return;

	removeFromSet(playGui, $FlagHUD::Container);
}

function Flag::Destroy() {

        removeFromSet(playGui, $FlagHUD::Container);
        deleteObject($FlagHUD::Container);
}

function Flag::Reset() {

	$Ftimer = 48;
	$Etimer = 48;
	$Escore = 0;
	$Fscore = 0;
	$FlagHUD::FriendlyCarrier = "";
	$FlagHUD::EnemyCarrier = "";
}

function Ftime() {

	if($FlagHUD::EnemyCarrier == "DROPPED") {
		$Ftimer--;
		Schedule::Add("Ftime();", 1);
		Flag::Update();
	}
	else {
		$Ftimer = 48;
	}
}

function Etime() {

	if($FlagHUD::FriendlyCarrier == "DROPPED") {
		$Etimer--;
		Schedule::Add("Etime();", 1);
		Flag::Update();
	}
	else {
		$Etimer = 48;
	}
}

function YouGrabbedFlag() {

	$FlagHUD::FriendlyCarrier = "You";
	$Etimer = 48;
	Flag::Update();
}

function TeamGrabbedFlag() {

        $FlagHUD::FriendlyCarrier = $FlagSnatcher;
	Target::Carrier();
	$Etimer = 48;
	Flag::Update();
}

function YourFlagTaken() {

	$FlagHUD::FlagSafe = 0;
        $FlagHUD::EnemyCarrier = $FlagSnatcher;
	$Ftimer = 48;
	Flag::Update();
}

function YourTeamCapped() {

        $FlagHUD::FlagSafe = 1;
        $FlagHUD::FriendlyCarrier = "";
        $FlagHUD::EnemyCarrier = "";
	$Etimer = 48;
	$Fscore++;
	Flag::Update();
}

function EnemyTeamCapped() {

	$FlagHUD::FlagSafe = 1;
        $FlagHUD::FriendlyCarrier = "";
        $FlagHUD::EnemyCarrier = "";
	$Ftimer = 48;
	$Escore++;
	Flag::Update();
}

function YourFlagReturned() {

	$FlagHUD::FlagSafe = 1;
        $FlagHUD::EnemyCarrier = "";
	Flag::Update();
}

function EnemyFlagReturned() {

        $FlagHUD::FriendlyCarrier = ""; 
	Flag::Update();
}

function YourFlagDropped() {

	$FlagHUD::EnemyCarrier = "DROPPED";
	Schedule::Cancel("Ftime();");
	Ftime();
	Flag::Update();
}

function EnemyFlagDropped() {

	$FlagHUD::FriendlyCarrier = "DROPPED";
	Schedule::Cancel("Etime();");
	Etime(); 
	Flag::Update();
}

onCall(YouHaveFlag, YouGrabbedFlag);
onCall(TeamHasFlag, TeamGrabbedFlag);
onCall(FriendlyFlagTaken, YourFlagTaken);
onCall(FriendlyFlagCapture, YourTeamCapped);
onCall(EnemyFlagCapture, EnemyTeamCapped);
onCall(FriendlyFlagReturned, YourFlagReturned);
onCall(EnemyFlagReturned, EnemyFlagReturned);
onCall(FriendlyFlagDropped, YourFlagDropped);
onCall(EnemyFlagDropped, EnemyFlagDropped);
onCall(GuiOpen, Flag::GuiOpen);
onCall(GuiClose, Flag::GuiClose);
onCall(MapChange, Flag::Reset);
onCall(ExitGame, Flag::Destroy);

Flag::Init();

